﻿using Infragistics.Windows;
using Infragistics.Windows.Controls;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using RefreshIssue.Model;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamTabControl_sample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        ObservableCollection<EntryModel> FChooserEntry = new ObservableCollection<EntryModel>();
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }

        private void xdg_FieldChooserOpening(object sender, Infragistics.Windows.DataPresenter.Events.FieldChooserOpeningEventArgs e)
        {
            //win = Utilities.GetAncestorFromType(e.FieldChooser, typeof(ToolWindow), false) as ToolWindow;
            //win.Closing += WinClosing;

            FChooserEntry = new ObservableCollection<EntryModel>();
            e.Cancel = true;

            foreach (var entry in xdg.FieldLayouts[0].Fields)
            {
                FChooserEntry.Add(new EntryModel()
                {
                    FName = entry.Name.ToString(),
                    IsVisible = (entry.Visibility == Visibility.Visible) ? true : false ,  
                    Category = entry.Tag.ToString()
                });
            }
            xdgInChooser.DataContext = FChooserEntry;

            dialog.WindowState = Infragistics.Controls.Interactions.WindowState.Normal;

            dialog.WindowStateChanged += Dialog_WindowStateChanged;
        }

        private void Dialog_WindowStateChanged(object sender, Infragistics.Controls.Interactions.WindowStateChangedEventArgs e)
        {
            if (e.NewWindowState == Infragistics.Controls.Interactions.WindowState.Hidden)
            {
                int i = xdg.FieldLayouts[0].Fields.Count - 1;
                while (i >= 0)
                {
                    switch (FChooserEntry[i].IsVisible)
                    {
                        case false:
                            xdg.FieldLayouts[0].Fields[i].Visibility = Visibility.Collapsed;
                            i--;
                            break;
                        default:
                            xdg.FieldLayouts[0].Fields[i].Visibility = Visibility.Visible;
                            i--;
                            break;
                    }

                }
            }
        }
    }
}
